<?php

// Hilfs-Variablen
$sSeparator = " | ";

//Variablen der bersicht halber, fr SELECT:
$d3varsel1 = "SUBSTR(oxvarselect, 1, INSTR(oxvarselect, '|')-1)" . PHP_EOL;

$d3varsel2Help = "SUBSTR(oxvarselect, INSTR(oxvarselect, '|')+1)". PHP_EOL;
// nur bis varsel3
$two2three = "INSTR($d3varsel2Help, '|')-1". PHP_EOL;
$d3varsel2 = "SUBSTR(oxvarselect, INSTR(oxvarselect, '|')+1, $two2three)". PHP_EOL;

$d3varsel3Help = "SUBSTR($d3varsel2Help, INSTR($d3varsel2Help, '|')+1)". PHP_EOL;
//nur bis varsel4
$three2four = "INSTR($d3varsel3Help, '|')-1". PHP_EOL;
$d3varsel3 = "SUBSTR($d3varsel2Help, INSTR($d3varsel2Help, '|')+1, $three2four)". PHP_EOL;

$d3varsel4 = "SUBSTR($d3varsel3Help, INSTR($d3varsel3Help, '|')+1)". PHP_EOL;

// Bedingungen:
//$leer1 = " LOCATE(' ', $d3varsel1) ". PHP_EOL;   // LOCATE gibt 0 zurck, wenn kein leerzeichen gefunden wurde
//$summeLeerzeichen1 = " LENGTH($d3varsel1) - LENGTH(REPLACE($d3varsel1, ' ', '' )) ". PHP_EOL;

// wir entfernen am anfang bzw. am ende die leerezeichen
// anschlieend prfen ob die diefferenz 1 bzw. 2 ist -> dann ist korrekter weise am ende (und anfang) nur ein leerzeichen
$iLeerKontrolle1 = " LENGTH($d3varsel1) - LENGTH(RTRIM($d3varsel1)) ". PHP_EOL; // RTRIM(str) leerzeichen am ende entfernen
$iLeerKontrolle2 = " LENGTH($d3varsel2) - LENGTH(TRIM($d3varsel2)) ". PHP_EOL;
$iLeerKontrolle3 = " LENGTH($d3varsel3) - LENGTH(TRIM($d3varsel3)) ". PHP_EOL;
$iLeerKontrolle4 = " LENGTH($d3varsel4) - LENGTH(LTRIM($d3varsel4)) ". PHP_EOL; // LTRIM(str) leerzeichen am anfang entfernen

// 4-dimensionen
$sWhere4Dimensions = " WHERE `OXVARSELECT` != '' ". PHP_EOL;
$sWhere4Dimensions .= " AND ( ". PHP_EOL;
$sWhere4Dimensions .= "  ( ". PHP_EOL;
$sWhere4Dimensions .= "   $d3varsel1 NOT LIKE '' ". PHP_EOL;
$sWhere4Dimensions .= "   AND $d3varsel2 NOT LIKE '' ". PHP_EOL;
$sWhere4Dimensions .= "   AND $d3varsel3 NOT LIKE '' ". PHP_EOL;
$sWhere4Dimensions .= "   AND $d3varsel4 NOT LIKE '' ". PHP_EOL;
$sWhere4Dimensions .= "   AND ( ". PHP_EOL;
$sWhere4Dimensions .= "        $iLeerKontrolle1 != 1 ". PHP_EOL; // erste Variante
$sWhere4Dimensions .= "        OR $iLeerKontrolle2 != 2 ". PHP_EOL; // zweite Variante
$sWhere4Dimensions .= "        OR $iLeerKontrolle3 != 2 ". PHP_EOL; // dritte Variante
$sWhere4Dimensions .= "        OR $iLeerKontrolle4 != 1 ". PHP_EOL; // vierte Variante
$sWhere4Dimensions .= "       ) ". PHP_EOL;
$sWhere4Dimensions .= "  ) ". PHP_EOL;
$sWhere4Dimensions .= " ) ";
$sUpdate4Dimensions = " CONCAT_WS('$sSeparator',TRIM($d3varsel1), TRIM($d3varsel2), TRIM($d3varsel3), TRIM($d3varsel4)) ". PHP_EOL;

// 3-dimensionen
$sWhere3Dimensions = " WHERE `OXVARSELECT` != '' ". PHP_EOL;
$sWhere3Dimensions .= "  AND ( ". PHP_EOL;
$sWhere3Dimensions .= "  ( ". PHP_EOL;
$sWhere3Dimensions .= "   $d3varsel1 NOT LIKE '' ". PHP_EOL;
$sWhere3Dimensions .= "   AND $d3varsel2 NOT LIKE '' ". PHP_EOL;
$sWhere3Dimensions .= "   AND $d3varsel3 = '' ". PHP_EOL;
$sWhere3Dimensions .= "   AND $d3varsel4 NOT LIKE '' ". PHP_EOL;
$sWhere3Dimensions .= "   AND ( ". PHP_EOL;
$sWhere3Dimensions .= "        $iLeerKontrolle1 != 1 ". PHP_EOL; // erste Variante
$sWhere3Dimensions .= "        OR $iLeerKontrolle2 != 2 ". PHP_EOL; // zweite Variante
$sWhere3Dimensions .= "        OR $iLeerKontrolle4 != 1 ". PHP_EOL; // dritte Variante
$sWhere3Dimensions .= "       ) ". PHP_EOL;
$sWhere3Dimensions .= "  ) ". PHP_EOL;
$sWhere3Dimensions .= " ) ";
$sUpdate3Dimensions = " CONCAT_WS('$sSeparator',TRIM($d3varsel1), TRIM($d3varsel2), TRIM($d3varsel4)) ";

// 2-dimensionen
$sWhere2Dimensions = " WHERE `OXVARSELECT` != '' ". PHP_EOL;
$sWhere2Dimensions .= "  AND ( ". PHP_EOL;
$sWhere2Dimensions .= "  ( ". PHP_EOL;
$sWhere2Dimensions .= "   $d3varsel1 NOT LIKE '' ". PHP_EOL;
$sWhere2Dimensions .= "   AND $d3varsel2 = '' ". PHP_EOL;
$sWhere2Dimensions .= "   AND $d3varsel3 = '' ". PHP_EOL;
$sWhere2Dimensions .= "   AND $d3varsel4 NOT LIKE '' ". PHP_EOL;
$sWhere2Dimensions .= "   AND ( ". PHP_EOL;
$sWhere2Dimensions .= "        $iLeerKontrolle1 != 1 ". PHP_EOL; // erste Variante
$sWhere2Dimensions .= "        OR $iLeerKontrolle4 != 1 ". PHP_EOL; // zweite Variante
$sWhere2Dimensions .= "       ) ". PHP_EOL;
$sWhere2Dimensions .= "  )". PHP_EOL;
$sWhere2Dimensions .= ") ";
$sUpdate2Dimensions = " CONCAT_WS('$sSeparator',TRIM($d3varsel1), TRIM($d3varsel4)) ";

$aQueries = array(
    // 4-dimensionale Varianten
    array(
        'check' => "SELECT if(count(OXID), 1, 0) FROM oxarticles " . $sWhere4Dimensions,
        'do'    => "UPDATE `oxarticles` SET `OXVARSELECT` = " . $sUpdate4Dimensions . $sWhere4Dimensions,
    ),

    // 3-dimensionale Varianten
    array(
        'check' => "SELECT if(count(OXID), 1, 0) FROM oxarticles " . $sWhere3Dimensions,
        'do'    => "UPDATE `oxarticles` SET `OXVARSELECT` = " . $sUpdate3Dimensions . $sWhere3Dimensions,
    ),

    // 2-dimensionale Varianten
    array(
        'check' => "SELECT if(count(OXID), 1, 0) FROM oxarticles " . $sWhere2Dimensions,
        'do'    => "UPDATE `oxarticles` SET `OXVARSELECT` = " . $sUpdate2Dimensions . $sWhere2Dimensions,
    ),
);
